LOCAL loFirst, loSecond

loFirst = CREATEOBJECT("MyFirstClass")
loSecond = CREATEOBJECT("MySecondClass")

RETURN

*---------------------------------------------
DEFINE CLASS MyFirstClass AS CUSTOM

  PROCEDURE DESTROY
    WAIT WINDOW THIS.NAME
  ENDPROC
ENDDEFINE


*---------------------------------------------
DEFINE CLASS MySecondClass AS MyFirstClass
ENDDEFINE



LOCAL loFirst, loSecond

loFirst = CREATEOBJECT("MyFirstClass")
loSecond = CREATEOBJECT("MySecondClass")

loFirst = NULL
loSecond = NULL

RETURN

*---------------------------------------------
DEFINE CLASS MyFirstClass AS CUSTOM

  PROCEDURE DESTROY
    WAIT WINDOW THIS.NAME
  ENDPROC
ENDDEFINE


*---------------------------------------------
DEFINE CLASS MySecondClass AS MyFirstClass
ENDDEFINE


*   To understand this example, execute this program twice from the Command Window,
*   and then type Clear All in the Command Window.
*
*   Before the "Clear All", the objects will remain in memory.
*   After the "Clear All", the Destroy method will execute twice for every object.

LOCAL loFirst AS OBJECT, loSecond AS OBJECT

*-- Create an instance of MyFirstClass and assign it to loFirst
*   at this moment, the name table index (for MyFirstClass)
*   has a value of 1
loFirst = CREATEOBJECT("MyFirstClass")
MESSAGEBOX("First object created")

*-- Create an instance of MySecondClass and assign it to loSecond
*   at this moment, the name table index (for MySecondClass)
*   has a value of 1.
loSecond = CREATEOBJECT("MySecondClass")
MESSAGEBOX("Second object created")

*-- Now, the object loFirst is assigned a property in loSecond
*   and the Name Table Index (for MyFirstClass) becomes 2
loSecond.Pointer = loFirst
MESSAGEBOX("Second object has a pointer to the first object")

*-- Now, the object loSecond is assigned a property in loFirst
*   and the Name Table Index (for MySecondClass) becomes 2
*   with a circular reference
loFirst.Pointer = loSecond
MESSAGEBOX("First object has a pointer to the second object, and a circular reference is created")

MESSAGEBOX("Even when the variables get out of scope, DESTROY is not executed " +;
  + CHR(13) + CHR(13) + "REMEMBER TO EXECUTE CLEAR ALL AFTER THE SECOND RUN. ")


RETURN

*---------------------------------------------
DEFINE CLASS MyFirstClass AS CUSTOM
  Pointer = NULL

  PROCEDURE DESTROY
    MESSAGEBOX("Destroying " + THIS.NAME)
  ENDPROC
ENDDEFINE

*---------------------------------------------
DEFINE CLASS MySecondClass AS MyFirstClass
ENDDEFINE


LOCAL loForm AS FORM, loTextbox AS TEXTBOX

* -- In this example, we are doing two different things:
*    1  Creating an instance of a form (MyForm)
*    2  The form creates a Textbox
*    Name Table Index (for the form) is 1
*    Name Table Index (for the textbox) is 1
loForm = CREATEOBJECT("MyForm")

* -- Another pointer is assigned to the Textbox
*    Name Table Index (for the textbox) is 2
loTextbox = loForm.txtTest
READ EVENTS

*-- Now, Name Table Index (for the form) will be 0
*   The method Destroy is executed, and the Name Table Index (for the textbox) goes back to 1
*   But, since the textbox still has a reference to the form, it can't be destroyed.
loForm = .NULL.

=MESSAGEBOX('Variable loform has been assigned a NULL' + CHR(13) + CHR(13) + ;
  '  - loForm = .Null.' + CHR(13) + CHR(13) + ;
  'But it can't be freed FROM MEMORY, since a circular REFERENCE TO the TEXTBOX EXISTS' + CHR(13) + ;
  'the VALUE OF VARTYPE(loForm) IS "' + VARTYPE(loForm) + '"' + CHR(13) + ;
  'AND the VALUE OF loTextbox.VALUE IS "' + ALLTRIM(loTextbox.VALUE) + '"' + CHR(13) + CHR(13) + ;
  'AND ... the FORM IS VISIBLE.')

*-- Finally, the Garbage Collector can eliminate the references
loTextbox = NULL

=MESSAGEBOX('Finally, the form is dead' + CHR(13) + CHR(13) + ;
  'The reference to the textbox was assigned a NULL and the form was released.' + CHR(13) + CHR(13) + ;
  '  - loTextbox = NULL')

RETURN


DEFINE CLASS MyForm AS FORM

  ADD OBJECT txtTest AS TEXTBOX
  ADD OBJECT lblTest AS LABEL

  PROCEDURE INIT()

    WITH THIS
      .txtTest.LEFT    = 10
      .txtTest.TOP     = 40
      .txtTest.VALUE   = "Write something:"
      .txtTest.WIDTH   = 280
      .lblTest.LEFT    = 10
      .lblTest.TOP     = 80
      .lblTest.WIDTH   = 280
      .lblTest.CAPTION = "When you finish, press the X on the form to close it"
      .CAPTION         = "Demo: multiple references to an object " + TTOC(DATETIME(),1)
      .AUTOCENTER = .T.
      .VISIBLE    = .T.
    ENDWITH

  ENDPROC

  PROCEDURE DESTROY
    MESSAGEBOX("Destroying the form... ")
    CLEAR EVENTS
  ENDPROC
ENDDEFINE
